include qpolygon.e
include qfloor.e
include qpolyobj.e
include get.e

 ----------

sequence cube, pyramid, pyramid_point1, pyramid_point2,
	 pyramid_point3, pyramid_point4, cube_point1, cube_point2,
	 cube_point3, cube_point4, cube_point5, cube_point6,
	 cube_point7, cube_point8
qobject  myfloor, sky, cube_obj, pyramid_obj
object   junk, temp, temp2
atom     add, t

 ----------

myfloor = new_qobject ("Floor", {BRIGHT_WHITE, -MID_Y})

 -- set this too much higher, and the polygon() routine can't take it
 -- because the closest vertex will translate into a y-coord beyond
 -- the workable bounds for polygon()
sky = new_qobject ("Floor", {CYAN, floor (MAX_VY / 3.5)})

 ----------

cube = repeat ({}, 12)

cube_point1 = {-100, 100, 500}
cube_point2 = {-100, 100, 550}
cube_point3 = {-50, 100, 500}
cube_point4 = {-50, 100, 550}
cube_point5 = {-100, 50, 500}
cube_point6 = {-100, 50, 550}
cube_point7 = {-50, 50, 500}
cube_point8 = {-50, 50, 550}

 -- the back square
cube[1] = new_qobject ("Polygon", {BLUE,
	      cube_point2, cube_point4, cube_point6})
cube[2] = new_qobject ("Polygon", {BLUE,
	      cube_point4, cube_point6, cube_point8})

 -- the left square
cube[3] = new_qobject ("Polygon", {GREEN,
	      cube_point1, cube_point2, cube_point5})
cube[4] = new_qobject ("Polygon", {GREEN,
	      cube_point2, cube_point5, cube_point6})

 -- the top square
cube[5] = new_qobject ("Polygon", {WHITE,
	      cube_point1, cube_point2, cube_point3})
cube[6] = new_qobject ("Polygon", {WHITE,
	      cube_point2, cube_point3, cube_point4})

 -- the bottom square
cube[7] = new_qobject ("Polygon", {YELLOW,
	      cube_point5, cube_point6, cube_point7})
cube[8] = new_qobject ("Polygon", {YELLOW,
	      cube_point6, cube_point7, cube_point8})

 -- the right square
cube[9]  = new_qobject ("Polygon", {RED,
	      cube_point3, cube_point4, cube_point7})
cube[10] = new_qobject ("Polygon", {RED,
	      cube_point4, cube_point7, cube_point8})

 -- the front square
cube[11] = new_qobject ("Polygon", {GRAY,
	      cube_point1, cube_point3, cube_point5})
cube[12] = new_qobject ("Polygon", {GRAY,
	      cube_point3, cube_point5, cube_point7})

 ----------

pyramid = repeat ({}, 4)

 -- let's define an equilateral pyramid
pyramid_point1 = {-40 - sqrt (675), -MID_Y, 370}
pyramid_point2 = {-40, -MID_Y, 355}
pyramid_point3 = {-40, -MID_Y, 385}
pyramid_point4 = {-40 - sqrt (75), -MID_Y + sqrt (600), 370}

 -- the bottom face
pyramid[1] = new_qobject ("Polygon", {WHITE,
	      pyramid_point1, pyramid_point2, pyramid_point3})
 -- the back face
pyramid[2] = new_qobject ("Polygon", {BLUE,
	      pyramid_point1, pyramid_point3, pyramid_point4})
 -- the left face
pyramid[3] = new_qobject ("Polygon", {YELLOW,
	      pyramid_point1, pyramid_point2, pyramid_point4})
 -- the right face
pyramid[4] = new_qobject ("Polygon", {GREEN,
	      pyramid_point2, pyramid_point3, pyramid_point4})

 ----------

cube_obj    = new_qobject ("PolyObject", cube)
pyramid_obj = new_qobject ("PolyObject", pyramid)

 ----------

junk = graphics_mode (G_MODE)
clear_screen ()

 ----------

junk = send_qmessage (sky, "DrawSelf", 0)
junk = send_qmessage (myfloor, "DrawSelf", 0)

 ----------

--for i = 1 to 10 do
   junk = send_qmessage (send_qmessage (cube_obj, "MoveZ", 1000),
			 "DrawSelf", 0)
--end for

--for i = 1 to 10 do
   junk = send_qmessage (cube_obj, "DrawSelf", 0)
--end for

--for i = 1 to 10 do
   junk = send_qmessage (send_qmessage (cube_obj, "Rotate",
					{0, 30, 0, {0, 0, 0}}),
			 "DrawSelf", 0)
--end for

 ----------

temp = {(cube_point1[1] + cube_point3[1]) / 2,
	(cube_point1[2] + cube_point5[2]) / 2,
	cube_point1[3] - 25}
--for i = 1 to 10 do
   junk = send_qmessage (send_qmessage (cube_obj, "Rotate",
					{0, -90, 0, temp}),
			 "DrawSelf", 0)

   junk = send_qmessage (send_qmessage (cube_obj, "Rotate",
					{-90, 0, 0, temp}),
			 "DrawSelf", 0)

   junk = send_qmessage (send_qmessage (cube_obj, "Rotate",
					{90, 0, 0, temp}),
			 "DrawSelf", 0)

   junk = send_qmessage (send_qmessage (cube_obj, "Rotate",
					{0, 90, 0, temp}),
			 "DrawSelf", 0)

   junk = send_qmessage (send_qmessage (cube_obj, "Rotate",
					{0, 180, 0, temp}),
			 "DrawSelf", 0)
--end for

 ----------

--for i = 1 to 3 do
   junk = send_qmessage (pyramid_obj, "DrawSelf", 0)
--end for

 ----------

--cube_obj = send_qmessage (cube_obj, "Rotate", {0, -90, 0, temp})

 ----------

if (0) then
   junk = wait_key ()
end if

if (0) then

   add = 0

   for i = 1 to 100 do
      clear_screen ()
      --for j = 1 to 10 do
	 junk = send_qmessage (send_qmessage (cube_obj, "MoveZ", add),
			       "DrawSelf", 0)
      --end for
      add = add + 10
   end for

end if

 ----------

temp[3] = cube_point1[3] - 100
temp2 = temp
temp2[1] = temp2[1] + 300
temp2[3] = temp2[3] + 300
t = time()
for i = 0 to 360 do
   clear_screen ()
    -- rotate the original around it's axis
   junk = send_qmessage (send_qmessage (cube_obj, "Rotate", {0,i,0}),
			       "DrawSelf", 0)
    -- rotate a copy around a point 100 units in front of itself
   junk = send_qmessage (send_qmessage (cube_obj, "Rotate",
			 {0, i, 0, temp}), "DrawSelf", 0)
    -- move a copy 300 units right, then rotate it around a point
    -- 150 units in front of itself
   junk = send_qmessage (send_qmessage (send_qmessage
			 (send_qmessage (cube_obj, "MoveX", 300),
					 "MoveZ", 350), "Rotate",
			 {i, 0, 0, temp2}), "DrawSelf", 0)
end for
t = time() - t
? t
if graphics_mode(-1) then
end if
