
include quartz.e
include qpolyobj.e
include get.e
include image.e

 ----------

without type_check

 ----------

 -- vertices for the head (w=10, h=12, d=10)
sequence HeadVertices
HeadVertices    = repeat({}, 8)
HeadVertices[1] = {-5, 32,-5}
HeadVertices[2] = {-5, 32, 5}
HeadVertices[3] = { 5, 32,-5}
HeadVertices[4] = { 5, 32, 5}
HeadVertices[5] = {-5, 20,-5}
HeadVertices[6] = {-5, 20, 5}
HeadVertices[7] = { 5, 20,-5}
HeadVertices[8] = { 5, 20, 5}

 -- vertices for the chest (w=22, h=10, d=12)
sequence ChestVertices
ChestVertices    = repeat({}, 8)
ChestVertices[1] = {-11, 20,-6}
ChestVertices[2] = {-11, 20, 6}
ChestVertices[3] = { 11, 20,-6}
ChestVertices[4] = { 11, 20, 6}
ChestVertices[5] = {-11, 10,-6}
ChestVertices[6] = {-11, 10, 6}
ChestVertices[7] = { 11, 10,-6}
ChestVertices[8] = { 11, 10, 6}

 -- vertices for the torso (w=18, h=10, d=10)
sequence TorsoVertices
TorsoVertices    = repeat({}, 8)
TorsoVertices[1] = {-9, 10,-5}
TorsoVertices[2] = {-9, 10, 5}
TorsoVertices[3] = { 9, 10,-5}
TorsoVertices[4] = { 9, 10, 5}
TorsoVertices[5] = {-9,  0,-5}
TorsoVertices[6] = {-9,  0, 5}
TorsoVertices[7] = { 9,  0,-5}
TorsoVertices[8] = { 9,  0, 5}

 -- vertices for an arm (w=8, h=10+14, d=8)
sequence ArmVertices
ArmVertices     = repeat({}, 12)
ArmVertices[1]  = {-4,  0,-4}
ArmVertices[2]  = {-4,  0, 4}
ArmVertices[3]  = { 4,  0,-4}
ArmVertices[4]  = { 4,  0, 4}
ArmVertices[5]  = {-4,-10,-4}
ArmVertices[6]  = {-4,-10, 4}
ArmVertices[7]  = { 4,-10,-4}
ArmVertices[8]  = { 4,-10, 4}
ArmVertices[9]  = {-4,-24,-4}
ArmVertices[10] = {-4,-24, 4}
ArmVertices[11] = { 4,-24,-4}
ArmVertices[12] = { 4,-24, 4}

 -- vertices for a leg (w=8, h=16+16, d=8)
sequence LegVertices
LegVertices     = repeat({}, 12)
LegVertices[1]  = {-4,  0,-4}
LegVertices[2]  = {-4,  0, 4}
LegVertices[3]  = { 4,  0,-4}
LegVertices[4]  = { 4,  0, 4}
LegVertices[5]  = {-4,-16,-4}
LegVertices[6]  = {-4,-16, 4}
LegVertices[7]  = { 4,-16,-4}
LegVertices[8]  = { 4,-16, 4}
LegVertices[9]  = {-4,-32,-4}
LegVertices[10] = {-4,-32, 4}
LegVertices[11] = { 4,-32,-4}
LegVertices[12] = { 4,-32, 4}

 -- create the polygons for the head, then combine into a polyobject
sequence HeadPolygons
HeadPolygons = repeat ({}, 10) -- bottom face of cube not needed
HeadPolygons[1]  = new_qobject ("Polygon", {GRAY, HeadVertices[1], HeadVertices[2], HeadVertices[3]})
HeadPolygons[2]  = new_qobject ("Polygon", {GRAY, HeadVertices[2], HeadVertices[3], HeadVertices[4]})
HeadPolygons[3]  = new_qobject ("Polygon", {GRAY, HeadVertices[2], HeadVertices[4], HeadVertices[6]})
HeadPolygons[4]  = new_qobject ("Polygon", {GRAY, HeadVertices[4], HeadVertices[6], HeadVertices[8]})
HeadPolygons[5]  = new_qobject ("Polygon", {GRAY, HeadVertices[1], HeadVertices[2], HeadVertices[6]})
HeadPolygons[6]  = new_qobject ("Polygon", {GRAY, HeadVertices[1], HeadVertices[5], HeadVertices[6]})
HeadPolygons[7]  = new_qobject ("Polygon", {GRAY, HeadVertices[3], HeadVertices[4], HeadVertices[8]})
HeadPolygons[8]  = new_qobject ("Polygon", {GRAY, HeadVertices[3], HeadVertices[7], HeadVertices[8]})
HeadPolygons[9]  = new_qobject ("Polygon", {WHITE, HeadVertices[1], HeadVertices[3], HeadVertices[5]})
HeadPolygons[10] = new_qobject ("Polygon", {WHITE, HeadVertices[3], HeadVertices[5], HeadVertices[7]})
qobject HeadObject
HeadObject = new_qobject ("PolyObject", HeadPolygons)

 -- create the polygons for the chest, then combine into a polyobject
sequence ChestPolygons
ChestPolygons = repeat ({}, 12)
ChestPolygons[1]  = new_qobject ("Polygon", {BLUE, ChestVertices[1], ChestVertices[2], ChestVertices[3]})
ChestPolygons[2]  = new_qobject ("Polygon", {BLUE, ChestVertices[2], ChestVertices[3], ChestVertices[4]})
ChestPolygons[3]  = new_qobject ("Polygon", {BLUE, ChestVertices[2], ChestVertices[4], ChestVertices[6]})
ChestPolygons[4]  = new_qobject ("Polygon", {BLUE, ChestVertices[4], ChestVertices[6], ChestVertices[8]})
ChestPolygons[5]  = new_qobject ("Polygon", {BLUE, ChestVertices[1], ChestVertices[2], ChestVertices[6]})
ChestPolygons[6]  = new_qobject ("Polygon", {BLUE, ChestVertices[1], ChestVertices[5], ChestVertices[6]})
ChestPolygons[7]  = new_qobject ("Polygon", {BLUE, ChestVertices[3], ChestVertices[4], ChestVertices[8]})
ChestPolygons[8]  = new_qobject ("Polygon", {BLUE, ChestVertices[3], ChestVertices[7], ChestVertices[8]})
ChestPolygons[9]  = new_qobject ("Polygon", {BLUE, ChestVertices[5], ChestVertices[6], ChestVertices[7]})
ChestPolygons[10] = new_qobject ("Polygon", {BLUE, ChestVertices[6], ChestVertices[7], ChestVertices[8]})
ChestPolygons[11] = new_qobject ("Polygon", {BLUE, ChestVertices[1], ChestVertices[2], ChestVertices[5]})
ChestPolygons[12] = new_qobject ("Polygon", {BLUE, ChestVertices[2], ChestVertices[5], ChestVertices[7]})
qobject ChestObject
ChestObject = new_qobject ("PolyObject", ChestPolygons)

 -- create the polygons for the torso, then combine into a polyobject
sequence TorsoPolygons
TorsoPolygons = repeat ({}, 10) -- the upper face is not needed
TorsoPolygons[1]  = new_qobject ("Polygon", {RED, TorsoVertices[2], TorsoVertices[4], TorsoVertices[6]})
TorsoPolygons[2]  = new_qobject ("Polygon", {RED, TorsoVertices[4], TorsoVertices[6], TorsoVertices[8]})
TorsoPolygons[3]  = new_qobject ("Polygon", {RED, TorsoVertices[1], TorsoVertices[2], TorsoVertices[6]})
TorsoPolygons[4]  = new_qobject ("Polygon", {RED, TorsoVertices[1], TorsoVertices[5], TorsoVertices[6]})
TorsoPolygons[5]  = new_qobject ("Polygon", {RED, TorsoVertices[3], TorsoVertices[4], TorsoVertices[8]})
TorsoPolygons[6]  = new_qobject ("Polygon", {RED, TorsoVertices[3], TorsoVertices[7], TorsoVertices[8]})
TorsoPolygons[7]  = new_qobject ("Polygon", {RED, TorsoVertices[5], TorsoVertices[6], TorsoVertices[7]})
TorsoPolygons[8]  = new_qobject ("Polygon", {RED, TorsoVertices[6], TorsoVertices[7], TorsoVertices[8]})
TorsoPolygons[9]  = new_qobject ("Polygon", {RED, TorsoVertices[1], TorsoVertices[2], TorsoVertices[5]})
TorsoPolygons[10] = new_qobject ("Polygon", {RED, TorsoVertices[2], TorsoVertices[5], TorsoVertices[7]})
qobject TorsoObject
TorsoObject = new_qobject ("PolyObject", TorsoPolygons)

 -- create the polygons for the arms, then combine into polyobjects
sequence ArmPolygons
ArmPolygons = repeat ({}, 20)
ArmPolygons[1]  = new_qobject ("Polygon", {YELLOW, ArmVertices[1], ArmVertices[2], ArmVertices[3]})
ArmPolygons[2]  = new_qobject ("Polygon", {YELLOW, ArmVertices[2], ArmVertices[3], ArmVertices[4]})
ArmPolygons[3]  = new_qobject ("Polygon", {YELLOW, ArmVertices[2], ArmVertices[4], ArmVertices[6]})
ArmPolygons[4]  = new_qobject ("Polygon", {YELLOW, ArmVertices[4], ArmVertices[6], ArmVertices[8]})
ArmPolygons[5]  = new_qobject ("Polygon", {YELLOW, ArmVertices[1], ArmVertices[2], ArmVertices[6]})
ArmPolygons[6]  = new_qobject ("Polygon", {YELLOW, ArmVertices[1], ArmVertices[5], ArmVertices[6]})
ArmPolygons[7]  = new_qobject ("Polygon", {YELLOW, ArmVertices[3], ArmVertices[4], ArmVertices[8]})
ArmPolygons[8]  = new_qobject ("Polygon", {YELLOW, ArmVertices[3], ArmVertices[7], ArmVertices[8]})
ArmPolygons[9]  = new_qobject ("Polygon", {YELLOW, ArmVertices[9], ArmVertices[10], ArmVertices[11]})
ArmPolygons[10] = new_qobject ("Polygon", {YELLOW, ArmVertices[10], ArmVertices[11], ArmVertices[12]})
ArmPolygons[11] = new_qobject ("Polygon", {YELLOW, ArmVertices[1], ArmVertices[2], ArmVertices[5]})
ArmPolygons[12] = new_qobject ("Polygon", {YELLOW, ArmVertices[2], ArmVertices[5], ArmVertices[7]})
ArmPolygons[13] = new_qobject ("Polygon", {YELLOW, ArmVertices[5], ArmVertices[7], ArmVertices[11]})
ArmPolygons[14] = new_qobject ("Polygon", {YELLOW, ArmVertices[5], ArmVertices[9], ArmVertices[11]})
ArmPolygons[15] = new_qobject ("Polygon", {YELLOW, ArmVertices[5], ArmVertices[6], ArmVertices[10]})
ArmPolygons[16] = new_qobject ("Polygon", {YELLOW, ArmVertices[5], ArmVertices[9], ArmVertices[10]})
ArmPolygons[17] = new_qobject ("Polygon", {YELLOW, ArmVertices[7], ArmVertices[8], ArmVertices[12]})
ArmPolygons[18] = new_qobject ("Polygon", {YELLOW, ArmVertices[7], ArmVertices[11], ArmVertices[12]})
ArmPolygons[19] = new_qobject ("Polygon", {YELLOW, ArmVertices[6], ArmVertices[8], ArmVertices[10]})
ArmPolygons[20] = new_qobject ("Polygon", {YELLOW, ArmVertices[8], ArmVertices[10], ArmVertices[12]})
qobject Arm1Object, Arm2Object
Arm1Object = new_qobject ("PolyObject", ArmPolygons)
Arm1Object = send_qmessage (Arm1Object, "MoveY", 20)
Arm1Object = send_qmessage (Arm1Object, "MoveX", -15)
Arm2Object = send_qmessage (Arm1Object, "MoveX", 22+8)

 -- create the polygons for the legs, then combine into polyobjects
sequence LegPolygons
LegPolygons = repeat ({}, 20)
LegPolygons[1]  = new_qobject ("Polygon", {BLUE, LegVertices[1], LegVertices[2], LegVertices[3]})
LegPolygons[2]  = new_qobject ("Polygon", {BLUE, LegVertices[2], LegVertices[3], LegVertices[4]})
LegPolygons[3]  = new_qobject ("Polygon", {BLUE, LegVertices[2], LegVertices[4], LegVertices[6]})
LegPolygons[4]  = new_qobject ("Polygon", {BLUE, LegVertices[4], LegVertices[6], LegVertices[8]})
LegPolygons[5]  = new_qobject ("Polygon", {BLUE, LegVertices[1], LegVertices[2], LegVertices[6]})
LegPolygons[6]  = new_qobject ("Polygon", {BLUE, LegVertices[1], LegVertices[5], LegVertices[6]})
LegPolygons[7]  = new_qobject ("Polygon", {BLUE, LegVertices[3], LegVertices[4], LegVertices[8]})
LegPolygons[8]  = new_qobject ("Polygon", {BLUE, LegVertices[3], LegVertices[7], LegVertices[8]})
LegPolygons[9]  = new_qobject ("Polygon", {YELLOW, LegVertices[9], LegVertices[10], LegVertices[11]})
LegPolygons[10] = new_qobject ("Polygon", {YELLOW, LegVertices[10], LegVertices[11], LegVertices[12]})
LegPolygons[11] = new_qobject ("Polygon", {BLUE, LegVertices[1], LegVertices[2], LegVertices[5]})
LegPolygons[12] = new_qobject ("Polygon", {BLUE, LegVertices[2], LegVertices[5], LegVertices[7]})
LegPolygons[13] = new_qobject ("Polygon", {YELLOW, LegVertices[5], LegVertices[7], LegVertices[11]})
LegPolygons[14] = new_qobject ("Polygon", {YELLOW, LegVertices[5], LegVertices[9], LegVertices[11]})
LegPolygons[15] = new_qobject ("Polygon", {YELLOW, LegVertices[5], LegVertices[6], LegVertices[10]})
LegPolygons[16] = new_qobject ("Polygon", {YELLOW, LegVertices[5], LegVertices[9], LegVertices[10]})
LegPolygons[17] = new_qobject ("Polygon", {YELLOW, LegVertices[7], LegVertices[8], LegVertices[12]})
LegPolygons[18] = new_qobject ("Polygon", {YELLOW, LegVertices[7], LegVertices[11], LegVertices[12]})
LegPolygons[19] = new_qobject ("Polygon", {YELLOW, LegVertices[6], LegVertices[8], LegVertices[10]})
LegPolygons[20] = new_qobject ("Polygon", {YELLOW, LegVertices[8], LegVertices[10], LegVertices[12]})
qobject Leg1Object, Leg2Object
Leg1Object = new_qobject ("PolyObject", LegPolygons)
Leg1Object = send_qmessage (Leg1Object, "MoveX", -5)
Leg2Object = send_qmessage (Leg1Object, "MoveX", 18-8)

 -- now we place the polyobjects in a sequence, which we use as the
 -- basis for generating a single displayable polyobject as needed.
 -- When we want to display them (after tweaking and manipulating
 -- the individual parts as we please), we gather all of the polygons
 -- from all of the polyobjects, shove them into a new polyobject,
 -- and then display the new one
sequence PolyManParts, PolyManPolygons
qobject  Part, PolyMan
object   Junk
integer  page, ii

PolyManParts = {HeadObject, ChestObject, TorsoObject, Arm1Object,
		Arm2Object, Leg1Object, Leg2Object}
PolyManPolygons = {}

 -- move polyman away from the absolute origin so we can draw him
 -- (we'll gather the polygons from each polyobject while we're at it)
for i = 1 to length (PolyManParts) do
   Part = PolyManParts[i]
   Part = send_qmessage (Part, "MoveZ", 150)
   PolyManPolygons = PolyManPolygons &
		     send_qmessage (Part, "GetPolygons", 0)
   PolyManParts[i] = Part
end for

PolyMan = new_qobject ("PolyObject", PolyManPolygons)
Junk = graphics_mode (13)

while (get_key() = -1) do
page = 0
ii = 10
for i = 5 to 360 by 5 do
   page = 1 - page
   set_display_page (page)
   clear_screen()
   Junk = PolyObject_DrawSelf (PolyObject_Rotate (PolyMan, {ii,i,0}), 0)
   set_active_page (page)
   ii = ii + 10
end for
end while
if graphics_mode(-1) then
end if
